// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/definition"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/predicate"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/term"
)

// DefinitionQuery is the builder for querying Definition entities.
type DefinitionQuery struct {
	config
	ctx        *QueryContext
	order      []definition.OrderOption
	inters     []Interceptor
	predicates []predicate.Definition
	withTerm   *TermQuery
	withFKs    bool
	modifiers  []func(*sql.Selector)
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the DefinitionQuery builder.
func (dq *DefinitionQuery) Where(ps ...predicate.Definition) *DefinitionQuery {
	dq.predicates = append(dq.predicates, ps...)
	return dq
}

// Limit the number of records to be returned by this query.
func (dq *DefinitionQuery) Limit(limit int) *DefinitionQuery {
	dq.ctx.Limit = &limit
	return dq
}

// Offset to start from.
func (dq *DefinitionQuery) Offset(offset int) *DefinitionQuery {
	dq.ctx.Offset = &offset
	return dq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (dq *DefinitionQuery) Unique(unique bool) *DefinitionQuery {
	dq.ctx.Unique = &unique
	return dq
}

// Order specifies how the records should be ordered.
func (dq *DefinitionQuery) Order(o ...definition.OrderOption) *DefinitionQuery {
	dq.order = append(dq.order, o...)
	return dq
}

// QueryTerm chains the current query on the "term" edge.
func (dq *DefinitionQuery) QueryTerm() *TermQuery {
	query := (&TermClient{config: dq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := dq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := dq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(definition.Table, definition.FieldID, selector),
			sqlgraph.To(term.Table, term.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, definition.TermTable, definition.TermColumn),
		)
		fromU = sqlgraph.SetNeighbors(dq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Definition entity from the query.
// Returns a *NotFoundError when no Definition was found.
func (dq *DefinitionQuery) First(ctx context.Context) (*Definition, error) {
	nodes, err := dq.Limit(1).All(setContextOp(ctx, dq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{definition.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (dq *DefinitionQuery) FirstX(ctx context.Context) *Definition {
	node, err := dq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Definition ID from the query.
// Returns a *NotFoundError when no Definition ID was found.
func (dq *DefinitionQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = dq.Limit(1).IDs(setContextOp(ctx, dq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{definition.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (dq *DefinitionQuery) FirstIDX(ctx context.Context) int {
	id, err := dq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Definition entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Definition entity is found.
// Returns a *NotFoundError when no Definition entities are found.
func (dq *DefinitionQuery) Only(ctx context.Context) (*Definition, error) {
	nodes, err := dq.Limit(2).All(setContextOp(ctx, dq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{definition.Label}
	default:
		return nil, &NotSingularError{definition.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (dq *DefinitionQuery) OnlyX(ctx context.Context) *Definition {
	node, err := dq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Definition ID in the query.
// Returns a *NotSingularError when more than one Definition ID is found.
// Returns a *NotFoundError when no entities are found.
func (dq *DefinitionQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = dq.Limit(2).IDs(setContextOp(ctx, dq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{definition.Label}
	default:
		err = &NotSingularError{definition.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (dq *DefinitionQuery) OnlyIDX(ctx context.Context) int {
	id, err := dq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Definitions.
func (dq *DefinitionQuery) All(ctx context.Context) ([]*Definition, error) {
	ctx = setContextOp(ctx, dq.ctx, "All")
	if err := dq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Definition, *DefinitionQuery]()
	return withInterceptors[[]*Definition](ctx, dq, qr, dq.inters)
}

// AllX is like All, but panics if an error occurs.
func (dq *DefinitionQuery) AllX(ctx context.Context) []*Definition {
	nodes, err := dq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Definition IDs.
func (dq *DefinitionQuery) IDs(ctx context.Context) (ids []int, err error) {
	if dq.ctx.Unique == nil && dq.path != nil {
		dq.Unique(true)
	}
	ctx = setContextOp(ctx, dq.ctx, "IDs")
	if err = dq.Select(definition.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (dq *DefinitionQuery) IDsX(ctx context.Context) []int {
	ids, err := dq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (dq *DefinitionQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, dq.ctx, "Count")
	if err := dq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, dq, querierCount[*DefinitionQuery](), dq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (dq *DefinitionQuery) CountX(ctx context.Context) int {
	count, err := dq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (dq *DefinitionQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, dq.ctx, "Exist")
	switch _, err := dq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (dq *DefinitionQuery) ExistX(ctx context.Context) bool {
	exist, err := dq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the DefinitionQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (dq *DefinitionQuery) Clone() *DefinitionQuery {
	if dq == nil {
		return nil
	}
	return &DefinitionQuery{
		config:     dq.config,
		ctx:        dq.ctx.Clone(),
		order:      append([]definition.OrderOption{}, dq.order...),
		inters:     append([]Interceptor{}, dq.inters...),
		predicates: append([]predicate.Definition{}, dq.predicates...),
		withTerm:   dq.withTerm.Clone(),
		// clone intermediate query.
		sql:  dq.sql.Clone(),
		path: dq.path,
	}
}

// WithTerm tells the query-builder to eager-load the nodes that are connected to
// the "term" edge. The optional arguments are used to configure the query builder of the edge.
func (dq *DefinitionQuery) WithTerm(opts ...func(*TermQuery)) *DefinitionQuery {
	query := (&TermClient{config: dq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	dq.withTerm = query
	return dq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Definition.Query().
//		GroupBy(definition.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (dq *DefinitionQuery) GroupBy(field string, fields ...string) *DefinitionGroupBy {
	dq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &DefinitionGroupBy{build: dq}
	grbuild.flds = &dq.ctx.Fields
	grbuild.label = definition.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"created_at,omitempty"`
//	}
//
//	client.Definition.Query().
//		Select(definition.FieldCreatedAt).
//		Scan(ctx, &v)
func (dq *DefinitionQuery) Select(fields ...string) *DefinitionSelect {
	dq.ctx.Fields = append(dq.ctx.Fields, fields...)
	sbuild := &DefinitionSelect{DefinitionQuery: dq}
	sbuild.label = definition.Label
	sbuild.flds, sbuild.scan = &dq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a DefinitionSelect configured with the given aggregations.
func (dq *DefinitionQuery) Aggregate(fns ...AggregateFunc) *DefinitionSelect {
	return dq.Select().Aggregate(fns...)
}

func (dq *DefinitionQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range dq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, dq); err != nil {
				return err
			}
		}
	}
	for _, f := range dq.ctx.Fields {
		if !definition.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if dq.path != nil {
		prev, err := dq.path(ctx)
		if err != nil {
			return err
		}
		dq.sql = prev
	}
	return nil
}

func (dq *DefinitionQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Definition, error) {
	var (
		nodes       = []*Definition{}
		withFKs     = dq.withFKs
		_spec       = dq.querySpec()
		loadedTypes = [1]bool{
			dq.withTerm != nil,
		}
	)
	if dq.withTerm != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, definition.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Definition).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Definition{config: dq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if len(dq.modifiers) > 0 {
		_spec.Modifiers = dq.modifiers
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, dq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := dq.withTerm; query != nil {
		if err := dq.loadTerm(ctx, query, nodes, nil,
			func(n *Definition, e *Term) { n.Edges.Term = e }); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (dq *DefinitionQuery) loadTerm(ctx context.Context, query *TermQuery, nodes []*Definition, init func(*Definition), assign func(*Definition, *Term)) error {
	ids := make([]int, 0, len(nodes))
	nodeids := make(map[int][]*Definition)
	for i := range nodes {
		if nodes[i].term_definitions == nil {
			continue
		}
		fk := *nodes[i].term_definitions
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(term.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "term_definitions" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}

func (dq *DefinitionQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := dq.querySpec()
	if len(dq.modifiers) > 0 {
		_spec.Modifiers = dq.modifiers
	}
	_spec.Node.Columns = dq.ctx.Fields
	if len(dq.ctx.Fields) > 0 {
		_spec.Unique = dq.ctx.Unique != nil && *dq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, dq.driver, _spec)
}

func (dq *DefinitionQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(definition.Table, definition.Columns, sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt))
	_spec.From = dq.sql
	if unique := dq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if dq.path != nil {
		_spec.Unique = true
	}
	if fields := dq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, definition.FieldID)
		for i := range fields {
			if fields[i] != definition.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := dq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := dq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := dq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := dq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (dq *DefinitionQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(dq.driver.Dialect())
	t1 := builder.Table(definition.Table)
	columns := dq.ctx.Fields
	if len(columns) == 0 {
		columns = definition.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if dq.sql != nil {
		selector = dq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if dq.ctx.Unique != nil && *dq.ctx.Unique {
		selector.Distinct()
	}
	for _, m := range dq.modifiers {
		m(selector)
	}
	for _, p := range dq.predicates {
		p(selector)
	}
	for _, p := range dq.order {
		p(selector)
	}
	if offset := dq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := dq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// Modify adds a query modifier for attaching custom logic to queries.
func (dq *DefinitionQuery) Modify(modifiers ...func(s *sql.Selector)) *DefinitionSelect {
	dq.modifiers = append(dq.modifiers, modifiers...)
	return dq.Select()
}

// DefinitionGroupBy is the group-by builder for Definition entities.
type DefinitionGroupBy struct {
	selector
	build *DefinitionQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (dgb *DefinitionGroupBy) Aggregate(fns ...AggregateFunc) *DefinitionGroupBy {
	dgb.fns = append(dgb.fns, fns...)
	return dgb
}

// Scan applies the selector query and scans the result into the given value.
func (dgb *DefinitionGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, dgb.build.ctx, "GroupBy")
	if err := dgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*DefinitionQuery, *DefinitionGroupBy](ctx, dgb.build, dgb, dgb.build.inters, v)
}

func (dgb *DefinitionGroupBy) sqlScan(ctx context.Context, root *DefinitionQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(dgb.fns))
	for _, fn := range dgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*dgb.flds)+len(dgb.fns))
		for _, f := range *dgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*dgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := dgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// DefinitionSelect is the builder for selecting fields of Definition entities.
type DefinitionSelect struct {
	*DefinitionQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (ds *DefinitionSelect) Aggregate(fns ...AggregateFunc) *DefinitionSelect {
	ds.fns = append(ds.fns, fns...)
	return ds
}

// Scan applies the selector query and scans the result into the given value.
func (ds *DefinitionSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, ds.ctx, "Select")
	if err := ds.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*DefinitionQuery, *DefinitionSelect](ctx, ds.DefinitionQuery, ds, ds.inters, v)
}

func (ds *DefinitionSelect) sqlScan(ctx context.Context, root *DefinitionQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(ds.fns))
	for _, fn := range ds.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*ds.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ds.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// Modify adds a query modifier for attaching custom logic to queries.
func (ds *DefinitionSelect) Modify(modifiers ...func(s *sql.Selector)) *DefinitionSelect {
	ds.modifiers = append(ds.modifiers, modifiers...)
	return ds
}
